﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Projecturo.ProjecturoClient.Command;
using System.Windows.Input;
using Projecturo.ProjecturoClient.Connection;

namespace Projecturo.ProjecturoClient.ViewModel.Project
{
    public class VersionViewModel : WorkspaceViewModel
    {
        private Projecturo.Model.Version version;
        private Projecturo.Model.Project project;

        public VersionViewModel()
        {
            this.version = new Projecturo.Model.Version();
            Version.Name = "New Version";
        }

        public override string DisplayName
        {
            get
            {
                return Version.Name;
            }
            protected set
            {
                base.DisplayName = value;
                OnPropertyChanged("DisplayName");
            }
        }

        protected override void Save()
        {
            Version.CreateDate = DateTime.Now;
            Version.Project = this.project;
            Connector.Connectivity.Storage.Save(Version);
        }

        private Projecturo.Model.Version Version
        {
            get { return this.version; }
        }

        public string Name
        {
            get { return Version.Name; }
            set
            {
                if (Version.Name == value)
                    return;

                Version.Name = value;
                OnPropertyChanged("Name");
            }
        }

        public string Description
        {
            get { return Version.Description; }
            set
            {
                if (Version.Description == value)
                    return;

                Version.Description = value;
                OnPropertyChanged("Description");
            }
        }

        public override void SetParent(object parent)
        {
            this.project = parent as Projecturo.Model.Project;
        }
    }
}
